#-*- coding: Utf-8 -*-
# Author : Stéphane DUTERTRE
# Date : 12/04/19
# Description : Extracts a compressed data from a bit stream thanks to an opcode 
# Version : 1.0.0.0

from SigfoxFifo_1_00 import SigfoxFifoObject, DeltaCompression

# this class is able to extract a commpressed data from a bit stream
class SigfoxDataObject :
    def __init__( self, SigfoxFifo, Format = 16 ) :
        # on vérifie un minimum de chose
        if(    ( Format != 8  ) 
           and ( Format != 16 )
           and ( Format != 32 ) ) :
            # on génère une exception 
            raise( '"Format" must be 8 or 16 or 32' )
        self.Fifo   = SigfoxFifo
        self.Format = Format
        self.Number = 0
    def Initialization( self, SigfoxFifo, Format = 16 ) :
        # on vérifie un minimum de chose
        if(    ( Format != 8  ) 
           and ( Format != 16 )
           and ( Format != 32 ) ) :
            # on génère une exception 
            raise( '"Format" must be either 8 or 16 or 32' )
        self.Fifo   = SigfoxFifo
        self.Format = Format
        self.Number = 0
    def Extract( self, Opcode ) :
        # on vérifie que l'opcode existe
        if( Opcode != None ) :
            # on regarde s'il y a un signe
            BitCount    = Opcode[ 3 ]
            # on fixe le signe à 0
            Sign        = False
            # c'est tout le temps vrai sauf pour l'opde '9'
            if( Opcode[ 1 ] == 0b1001 ) :
                BitCount = self.Format
            # On regarde si l'on doit récupérer le signe
            if( Opcode[ 2 ] != 0 ) :
                Sign = bool( self.Fifo.Pop() > 0 )
            # on part de 0
            Decoded = 0
            # on récupère la donnée
            for Count in range( 0, BitCount ) :
                # on regarde si l'on est arrivé au bout
                if( self.Fifo.IsEnded() ) :
                    # On sort ici car il n'y a plus de données
                    return None
                # on récupère les bits des données
                Decoded = ( Decoded << 1 ) | self.Fifo.Pop()
            # On regarde s'il s'agit d'une valeur brute
            if( Opcode[ 1 ] == 0b1001 ) :
                self.Number   = Decoded 
            # on regarde si l'on doit signed ou pas l'écart
            elif Sign :
                self.Number  -= Decoded + Opcode[ 4 ]
            else :
                self.Number  += Decoded + Opcode[ 4 ]
            # on retourne la valeur
            return self.Number
        # on retourne 0
        return None
