#-*- coding: Utf-8 -*-
# Author : Stéphane DUTERTRE
# Date : 12/04/19
# Description : Decodes Sigfox payload

from SigfoxPayload_1_00 import SigfoxPayloadObject

# Pour un T° Outdoor (201)
print('----------------------------------------------------')
print('Capteur T° outdoor')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'C90402010c09280809241043' )

if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
    print( 'Trame incomplète' )

myPayLoad.Add( 'C9140209249000' )

if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
    print( 'Trame incomplète' )

myPayLoad.Add( 'c92473e00e' )

if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
    print( 'Trame incomplète' )
    
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de canaux = ' + str( myPayLoad.Execute() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )

for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( myPayLoad.ChannelFunctionOf( List ) )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

# Pour un S0 (203)
print('----------------------------------------------------')
print('Capteur S0')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'CB0401010B09000000F6FFFF' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
myPayLoad.Add( 'CB14FFFFFF03' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( myPayLoad.ChannelFunctionOf( List ) )
    print( 'Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( 'Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )
    
#pour un T°Hgr (202)
print('----------------------------------------------------')
print('Capteur T°/Hgr')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'ca040001100f0950624b9254' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
myPayLoad.Add( 'ca144aad0445531c2efe6a0d' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
myPayLoad.Add( 'ca2409a862dbadb5d65b737b' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
myPayLoad.Add( 'ca3437e6cef40e' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( myPayLoad.ChannelFunctionOf( List ) )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#pour un T°Hgr (200)
print('----------------------------------------------------')
print('Capteur Ventilation')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( '4c25c800340024' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#pour un VMC-Gaz (208)
print('----------------------------------------------------')
print('Capteur VMC-Gaz')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'D000058606640065013800' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

# Pour un T° Outdoor (205)
#print('----------------------------------------------------')
#print('Capteur T° indoor')
#print('----------------------------------------------------')
#myPayLoad = SigfoxPayloadObject( 'c90402011409d0a84214a256' )
#myPayLoad.Add( 'cd1492a4488a46ac4cbf0b04' )
#myPayLoad.Add( 'cd2473e00e' )
#print( "Données d'entrée = " + myPayLoad.Input() )
#print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
#for List in range( 0, myPayLoad.ListNumber() ) :
#    print( '   Champ = ' + str( myPayLoad.DataUnitOf( List ) ) )
#    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#trame d'informations
print('----------------------------------------------------')
print('Trame d\'informations')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'd1030023030000020000' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#trame d'alarme
print('----------------------------------------------------')
print('Trame d\'alarme - Ex 1 ')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'd1020e010b' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) + ' (' + str( myPayLoad.AlarmType() ) + ')' )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#trame d'alarme
print('----------------------------------------------------')
print('Trame d\'alarme - Ex 2 ')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'ca020301' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) + ' (' + str( myPayLoad.AlarmType() ) + ')' )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

#trame d'alarme
print('----------------------------------------------------')
print('Trame d\'alarme - Ex 3 ')
print('----------------------------------------------------')
myPayLoad = SigfoxPayloadObject( 'D1020e0175' )
if myPayLoad.IsFullyLoaded():
    print( 'Trame complète' )
else:
	print( 'Trame incomplète' )
print( "Données d'entrée = " + myPayLoad.Input() )
print( 'Nombre de listes = ' + str( myPayLoad.Execute() ) )
# print( 'Nombre de listes = ' + str( myPayLoad.ChannelNumber() ) )
print( 'Nom du capteur   = ' + myPayLoad.ProductName() + ' (' + str( myPayLoad.ProductType()) + ')' )
print( 'Type de message  = ' + myPayLoad.MessageName() )
for List in range( 0, myPayLoad.ChannelNumber() ) :
    print( 'Fonction = ' + str( myPayLoad.ChannelFunctionOf( List ) ) + ' (' + str( myPayLoad.AlarmType() ) + ')' )
    print( '   Champ = ' + str( myPayLoad.ChannelUnitOf( List ) ) )
    print( '   Data  = ' + str( myPayLoad.ChannelDataOf( List ) ) )

input("Press space to quit...")
