#-*- coding: Utf-8 -*-
# Author : Stéphane DUTERTRE
# Date : 12/04/19
# Description : Decodes Sigfox raw payload
# Version : 1.0.0.0

# this class is able to extract raw data
class SigfoxRawDecoderObject :
    def __init__( self, Format = 16, PayLoad = "" ) :
        # on vérifie un minimum de chose
        if(    (    ( Format != 8  )
                and ( ( len( PayLoad ) % ( Format / 8  ) ) == 0 ) )
           and (    ( Format != 16 )
                and ( ( len( PayLoad ) % ( Format / 16 ) ) == 0 ) )
           and (    ( Format != 32 )
                and ( ( len( PayLoad ) % ( Format / 32 ) ) == 0 ) ) ) :
            # on génère une exception 
            raise( '"Format" must be either 8 or 16 or 32' )
        # on note le format
        self.Format  = Format 
        # on note le paylaod
        self.PayLoad = PayLoad
        # on initialise la Liste
        self.Array   = []
    def Initialization( self, Format = 16, PayLoad = "" ) :
        # on vérifie un minimum de chose
        if(    (    ( Format != 8  )
                and ( ( len( PayLoad ) % ( Format / 8  ) ) == 0 ) )
           and (    ( Format != 16 )
                and ( ( len( PayLoad ) % ( Format / 16 ) ) == 0 ) )
           and (    ( Format != 32 )
                and ( ( len( PayLoad ) % ( Format / 32 ) ) == 0 ) ) ) :
            # on génère une exception 
            raise( '"Format" must be 8 or 16 or 32' )
        # on note le format
        self.Format  = Format
        # on note le paylaod
        self.PayLoad = PayLoad
        # on initialise la Liste
        self.Array.clear()
    def Execute( self ) :
        # on boucle
        for Count in range( 0, int( len( self.PayLoad ) / ( self.Format / 4 ) ) ) :
            # On prépare la donnée
            Data = 0
            # On récupère les octets
            for ByteCount in range( 0, int( self.Format / 8 ) ) :
                # on tente de décoder les données
                Data   += ( int( '0x' + self.PayLoad[ Count * int( self.Format / 4 ) + ByteCount * 2 ], 16 ) * 16 + int( '0x' + self.PayLoad[ Count * int( self.Format / 4 ) + ByteCount * 2 + 1 ], 16 ) ) << ( 8 * ByteCount )
            # On regarde si l'on a réussi à décoder qque chose
            self.Array.append( Data )
        # on retourne le nombre d'éléments
        return len( self.Array )
    def String( self ) :
        return self.PayLoad
    def Size( self ) :
        return len( self.Array )
    def Reverse( self ) :
        self.Array.reverse()
    def Data( self, Index ) :
        if( int( Index ) < len( self.Array ) ) :
            return self.Array[ int( Index ) ]
        else :
            return None
    def Result( self ) :
        return self.Array
