#-*- coding: Utf-8 -*-
# Author : Stéphane DUTERTRE
# Date : 12/04/19
# Description : Decodes Sigfox compressed payload
# Version : 1.0.0.0

from SigfoxFifo_1_00   import SigfoxFifoObject
from SigfoxOpcode_1_00 import SigfoxOpcodeObject
from SigfoxData_1_00   import SigfoxDataObject

# this class is able to extract compressed data
class SigfoxZipDecoderObject( SigfoxOpcodeObject, SigfoxDataObject ) :
    Fifo = SigfoxFifoObject( '' )
    def __init__( self, Format = 16, PayLoad = "" ) :
        # on vérifie un minimum de chose
        if(    ( Format != 8  ) 
           and ( Format != 16 )
           and ( Format != 32 ) ) :
            # on génère une exception 
            raise( '"Format" must be either 8 or 16 or 32' )
        # on initilialise la Fifo
        self.Fifo.Initialization( PayLoad )
        # on initialise la classe mère avec la FIFO
        SigfoxOpcodeObject.__init__( self, self.Fifo )
        # on initialise la classe mère avec la FIFO et le format
        SigfoxDataObject.__init__( self, self.Fifo, Format )
        # on initialise la Liste
        self.Array = []
    def Initialization( self, Format = 16, PayLoad = "" ) :
        # on vérifie un minimum de chose
        if(    ( Format != 8  ) 
           and ( Format != 16 )
           and ( Format != 32 ) ) :
            # on génère une exception 
            raise( '"Format" must be 8 or 16 or 32' )
        # on réinitialise la FIFO
        self.Fifo.Initialization( PayLoad )
        # on réinitalise la classe mère
        SigfoxOpcodeObject.Initialization( self, self.Fifo )
        # on réinitalise la classe mère et le format
        SigfoxDataObject.Initialization( self, self.Fifo, Format )
        # on initialise la Liste
        self.Array.clear()
    def Execute( self ) :
        # on boucle
        while( True ) :
            # on va récupérer l'opcode
            Opcode = SigfoxOpcodeObject.Extract( self )
            #on regarde si l'on a un opcode
            if( Opcode != None ) :
                # on tente de décoder les données
                Data = SigfoxDataObject.Extract( self, Opcode )
                # On regarde si l'on a réussi à décoder qque chose
                if( Data != None ) :
                    self.Array.append( Data )
                else :
                    break
            else :
                break
        # on retourne le nombre d'élément
        return len( self.Array )
    def String( self ) :
        return self.Fifo.String()
    def Size( self ) :
        return len( self.Array )
    def Reverse( self ) :
        self.Array.reverse()
    def Data( self, Index ) :
        if( int( Index ) < len( self.Array ) ) :
            return self.Array[ int( Index ) ]
        else :
            return None
    def Result( self ) :
        return self.Array

